/* From testgl.c */

#include <stdio.h>
#include <vga.h>
#include <vgagl.h>

#define LOGOWIDTH 201
#define LOGOHEIGHT 85

void loadbitmap(char *filename, void *buf)
{
	FILE *f;
	void *bufp;

	f = fopen(filename, "rb");
	bufp = buf;
 
	for (;;) {
		int count = fread(bufp, 1, 8192, f);
		if (count == 0)
			break;
		if (feof(f))
			break;
		bufp += count;
	}
	
	fclose(f);
}

void setcustompalette(void)
{
	/* colors 0-31 are an RGB mix (bits 0 and 1 r, 2 g, 3 and 4 b) */
	/* 32-63    black to red */
	/* 64-95    black to green */
	/* 96-127   black to yellow */
	/* 128-159  black to blue */
	/* 160-191  black to magenta */
	/* 192-223  black to cyan */
	/* 224-255  black to white */
	
	Palette pal;
	int i;
	
	for (i = 0; i < 256; i++) {
		int r, g, b;
		r = g = b = 0;
		if ((i & 32) > 0)
			r = (i & 31) << 1;
		if ((i & 64) > 0)
			g = (i & 31) << 1;
		if ((i & 128) > 0)
			b = (i & 31) << 1;
		if (i < 32) {
			r = (i & 3) << 4;   /* 2 bits */
			g = (i & 4) << 3;   /* 1 bit */
			b = (i & 24) << 1;  /* 2 bits */
		}
	        pal.color[i].red = r;
		pal.color[i].green = g;
		pal.color[i].blue = b;
	}
	
	gl_setpalette(&pal);
}


void logotest(void)
{
	int h;
	void *scaled;
	void *logobitmap;
	
	/* Set logo palette. */
	setcustompalette();
	/* Create logo bitmap */
	logobitmap = alloca(LOGOWIDTH * LOGOHEIGHT);
	loadbitmap("linuxlogo.bmp", logobitmap);
	/* Allocate buffer for scaled bitmap. */
	scaled = alloca(WIDTH * HEIGHT);
	gl_clearscreen(0);
	/* Stretch vertically. */
	for (h = 0; h <= LOGOHEIGHT; h++) {
		gl_scalebox(LOGOWIDTH, LOGOHEIGHT, logobitmap,
		            LOGOWIDTH, h, scaled);
		gl_putbox(0, 0, LOGOWIDTH, h, scaled);
	}
	gl_clearscreen(0);
	/* Scale to screen resolution. */
	gl_scalebox(LOGOWIDTH, LOGOHEIGHT, logobitmap, WIDTH, HEIGHT, scaled);
	gl_putbox(0, 0, WIDTH, HEIGHT, scaled);
}
